#include<iostream>
#include<fstream>
#include<string>
#include"simple.h"

using namespace std;

#define FILE_NAME "counter"

void usage() {
    cerr << "[ERROR] Bad numnber of parameters" << endl;
    cout << "    Usage: simple <counterValue>" << endl;
}

int main(int argc, char *argv[]) {
    // Check and get parameters
    if (argc != 2) {
        usage();
        return -1;
    }
    string initialValue = argv[1];
    file fileName = strdup(FILE_NAME);
    
    // Init compss
    compss_on();
    
    // Write file
    ofstream fos (fileName);
    if (fos.is_open()) {
        fos << initialValue << endl;
        fos.close();
    } else {
        cerr << "[ERROR] Unable to open file" << endl;
        return -1;
    }
    cout << "Initial counter value is " << initialValue << endl;
       
    // Execute increment
    increment(&fileName);
    compss_wait_on(fileName);
    
    // Read new value
    string finalValue;
    ifstream fis (fileName);
    if (fis.is_open()) {
        if (getline(fis, finalValue)) {
            cout << "Final counter value is " << finalValue << endl;
            fis.close();
        } else {
            cerr << "[ERROR] Unable to read final value" << endl;
            fis.close();
            return -1;
        }
    } else {
        cerr << "[ERROR] Unable to open file" << endl;
        return -1;
    }

    // Close COMPSs and end
    compss_off();
    return 0;
}
